def buildSuffix = project.properties['build.suffix']; /* jira6 or jira7? */
def buildNumber = project.properties['build.number'] ?: System.properties['build.number']; /* set externally */
def buildRelease = project.properties['build.release']; /* set in "release" profile */
String[] targetVersionArray = targetVersions.split(';')

def version = project.version;
def snapshot = project.version.endsWith('-SNAPSHOT');
if (snapshot) version = version.substring(0, version.length() - 9);

def suffixes = [];
def m = version =~ /^(.*)\.((rc|beta)\d*)$/;

if (m) {
  version = m.group(1);
  suffixes << m.group(2);
  /* maybe a comment here will help */
}
/* maybe a comment here will help */
if (!(version ==~ /\d+\.\d+\.\d+/)) {
  throw new AssertionError('\nBlocked by set-version execution: bad base version ' + version + '\n');
}

if (buildSuffix) suffixes << buildSuffix;
if (!buildRelease) {
  if (buildNumber && buildNumber != '0') {
    suffixes << buildNumber;
  } else if (snapshot) {
    suffixes << 'SNAPSHOT';
  }
}
if (suffixes) version += '.' + suffixes.join('-');

println('===== setting project version to ' + version + ' =====');

project.version = version;
project.build.finalName = project.artifactId + '-' + version;

for (String targetVersion: targetVersionArray) {
  project.properties[targetVersion] = version
}