define(
  'structure/pages/StructurePagesIntegrationConfig',
  [
    'almworks/jquery',
    'underscore',
    'almworks/util/Util'
  ],
  function ($, _, U) {
    'use strict';

    var IMPERSONATING_AUTH = [
      'OAUTH',
      'TWOLOIMP',
      'TRUSTED'
    ];

    function StructurePagesIntegrationConfig() {
      function toggleUserInput() {
        var value = $('.system-auth-select > select').val();
        $('.s-auth-user').toggle($.inArray(value, IMPERSONATING_AUTH) >= 0);
      }

      function toggleUserAuthWarning() {
        var value = $('.user-auth-select > select').val();
        $('.s-user-auth-warning').toggle(!!value && $.inArray(value, IMPERSONATING_AUTH) < 0);
      }

      function setupLoginLink() {
        var linkField$ = $('.login-url-link');
        if (!linkField$.length) return;

        var selectLink = function () {
          linkField$.focus();
          linkField$.select();
        };
        linkField$.click(selectLink);
        setTimeout(selectLink, 0);
      }

      function hideLoginWarning(providerType) {
        // TODO show this warning each time original impersonating provider selected back
        $('.s-impersonating-login-warning.' + providerType).hide();
      }

      U.extend(this, {
        install: function () {
          $(function () {
            toggleUserInput();
            $('.system-auth-select > select').change(U.seq(U.curry(hideLoginWarning, 'system'), toggleUserInput));
            toggleUserAuthWarning();
            $('.user-auth-select > select').change(U.seq(U.curry(hideLoginWarning, 'user'), toggleUserAuthWarning));
            setupLoginLink();
          });
        }
      });
    }

    return StructurePagesIntegrationConfig;
  });
